<?

GUIFactory::setMainGUI( "main" );

load_menu(301,$T_SETTING);

function resetSession( &$form, $param ) {
 global $SESSION_RESET, $JS, $STAG;
 $SESSION_RESET = true;
 $JS .= "top.location.href='$STAG&do=100';\n";
}

function getDbgModule( $dbg ) {
 $m = strtolower($dbg[0]);
 $m = str_replace(".", "-", $m);
 $m = str_replace(" ", "_", $m);
 if ($m == "") $m = "_";
 return $m;
}

function toggleDebug( &$form, $param ) {
 global $DEBUG_FLAGS;

 $debug =& $form->resolveComponent("tab.debug");
 $echo =& $debug->getComponent("debug_echo");
 $checked = array();
 foreach ($DEBUG_FLAGS as $key=>$dbg) {
 unset($dmod);
 $module = getDbgModule($dbg);
 if ($checked[$module]) continue;
 $dmod =& $debug->getComponent("dmod_$module");
 $dmod->setHidden(!$echo->isChecked());
 $checked[$module] = true;
 }
}

function storeValues( &$form, $param ) {
 global $ASSDELAY, $ONMOUSEOVER, $LANGUAGE, $NOSTREAM, $MYSTREAM, $GZCOMPRESS_LEVEL, $ASS_CHICK, $MYPROGRESS;
 global $FEATURE, $JS, $STAG, $STAG_PREFIX, $TREE_AUTOFLAP, $STREAMINFO_DEBUG, $DEBUG_SETTINGS, $DEBUG_FLAGS, $USER_ID;
 global $EMAIL_NOTIFICATION, $NOLOGINSTREAM, $MAXLISTITEMS;
 
 
 
 $onmouseover =& $form->resolveComponent("tab.main.onmouseover");
 $gzcompress =& $form->resolveComponent("tab.main.gzcompress");
 $lang =& $form->resolveComponent("tab.main.lang");
 $stream =& $form->resolveComponent("tab.streams.showstream");
 $loginstream =& $form->resolveComponent("tab.streams.loginstream");
 $streamimg =& $form->resolveComponent("tab.streams.streams");
 
 if( $FEATURE['itemlist_configurepagesize'] ) {
 $maxlistitems =& $form->resolveComponent("tab.main.maxlistitems");
 $MAXLISTITEMS = $maxlistitems->getSingleSelection();
 }
 if( $FEATURE['inbox_to_email_optional'] ) {
 $emailnotification =& $form->resolveComponent("tab.main.emailnotification");
 $inboxtoemail = $emailnotification->isChecked() ? 1 : 0;
 $sql = "UPDATE systemuser SET inboxtoemail = ".sqlf_tl_num($inboxtoemail)." WHERE id = ".sqlf_tl_num($USER_ID);
 query( $sql );
 }

 
 $over = ($onmouseover->getSingleSelection() == 2)?true:false;
 if ($ONMOUSEOVER != $over) {
 load_menu(-1,0,0,"",1);
 $ONMOUSEOVER = $over;
 }
 $JS .= "  if (parent.ass)
  parent.ass.location.reload();\n";
 
 if ($FEATURE["tree_autoflap"]) {
 $treeflap =& $form->resolveComponent("tab.main.treeflap");
 $tree = $treeflap->isChecked();
 if ($TREE_AUTOFLAP != $tree) {
 $TREE_AUTOFLAP = $tree;
 $JS .= "reload_tree();\n";
 }
 }
 
 if ($lang->getSingleSelection() != $LANGUAGE) {
 $JS .= "top.location.href='$STAG&do=100&do_list=410';\n";
 }
 $LANGUAGE = $lang->getSingleSelection();
 $NOSTREAM = false;
 if ($FEATURE["personalloginstream"] && $loginstream->isChecked()) {
 $NOLOGINSTREAM = 0;
 } else {
 $NOLOGINSTREAM = 1;
 }
 if ($streamimg->getSingleSelection() != $MYSTREAM) {
 $JS .= "top.tree.location.reload();top.logo.location.reload();\n";
 }
 $MYSTREAM = $streamimg->getSingleSelection();

 if (!$NOLOGINSTREAM) {
 setcookie("streamc",$MYSTREAM,time() + 365*24*3600*10);
 } else {
 setcookie("streamc","",1);
 }
 
 $GZCOMPRESS_LEVEL = $gzcompress->getSingleSelection();
 
 if ($FEATURE["progressbar"]) {
 $progress =& $form->resolveComponent("tab.progress");
 $MYPROGRESS = $progress->getSingleSelection();
 load_menu(-1,0,0,"",1);
 }

 $tab =& $form->resolveComponent("tab");
 if ($tab->tabExists("debug")) {
 $dlist =& $tab->getTab("debug");
 $exception =& $dlist->getComponent("exception");
 $stream =& $dlist->getComponent("stream");
 $assert =& $dlist->getComponent("assert");
 $info =& $dlist->getComponent("info");
 $STREAMINFO_DEBUG["debug"] = false;
 $STREAMINFO_DEBUG["exception"] = $exception->isChecked();
 $DEBUG_SETTINGS["assert"] = $assert->isChecked();
 $DEBUG_SETTINGS["noinfo"] = !$info->isChecked();

 if ($dlist->componentExists("debug_echo")) {
 $force =& $dlist->getComponent("debug_echo");
 $DEBUG_SETTINGS["debug_echo"] = $force->isChecked();
 foreach ($DEBUG_FLAGS as $key=>$dbg) {
 $module = getDbgModule($dbg);
 $dflag =& $dlist->resolveComponent("dmod_$module.c.debug_$key");
 $DEBUG_SETTINGS["debug_$key"] = $dflag->isChecked();
 unset($dflag);
 }
 }
 }
}

if ($debugForceHalt) halt(100,"simulated error event to debug sever error dialog.");

$form = new HtmlForm3("settings");
if ($form->isNew()) {

 node_class("listcomponent");
 node_class("textcomponent");
 node_class("radiolistcomponent");
 node_class("checkboxcomponent");
 node_class("tabcomponent");
 node_include("img");

 $main = new ListComponent();
 

 $lst = array();
 $sql = "SELECT id, name FROM language WHERE active = 1";
 $rs = query($sql);
 while (list($key,$val) = each($rs["arr"])) {
 if ($val["name"] != "Meta" || $DEBUG["echo"]) $lst[$val["id"]] = $val["name"];
 }

 $main->setComponent("lang", new SelectComponent(i18n("Language"), $lst, $LANGUAGE));

 $main->setComponent("onmouseover", new RadioListComponent(i18n("menu behaviour"), array("1"=>i18n("click"),"2"=>i18n("automatically")), ($ONMOUSEOVER)?2:1) );

 if( $FEATURE['inbox_to_email_optional'] ) {
 $sql = "SELECT inboxtoemail FROM systemuser WHERE id = ".sqlf_tl_num($USER_ID);
 $rs = query( $sql );
 $inboxtoemail = $rs['arr'][0]['inboxtoemail'];
 $emailNotification = new CheckboxComponent(i18n("Email Notification"), $inboxtoemail);
 $main->setComponent("emailnotification", $emailNotification);
 }

 if ($FEATURE["tree_autoflap"]) $main->setComponent("treeflap", new CheckboxComponent(i18n("tree open on click"), $TREE_AUTOFLAP));

 if (function_exists("gzcompress")) {
 $gzlst["0"] = i18n('lan_low_cpu_usage');
 $gzlst["9"] = i18n('modem_high_cpu_usage');
 } else {
 $gzlst["0"] = i18n('not_supported');
 }
 $defaultGzLevel = $FEATURE["use_default_gzcompress"] ? 9 : 0;
 $main->setComponent("gzcompress", new SelectComponent(i18n("connection"), $gzlst, isset($GZCOMPRESS_LEVEL)?$GZCOMPRESS_LEVEL:$defaultGzLevel) );

 if( $FEATURE['itemlist_configurepagesize'] ) {
 $main->setComponent("maxlistitems", new SelectComponent(i18n("Max items per page"), array( 'none' => i18n( 'No Paging' ), '5' => '5', '10' => '10', '20' => '20', '50' => '50' ), isset($MAXLISTITEMS)?$MAXLISTITEMS:(isset($DEFAULT_MAXLISTITEMS)?$DEFAULT_MAXLISTITEMS:'none') ) );
 }


 
 $bonus = get_bonus();
 reset($ASS_CHICK);
 while (list($k,$v) = each($ASS_CHICK)) {
 if ($bonus > $v["bonus"]) {
 $_list[$k] = $v["name"];
 $_src[$k] = img("$STAG_PREFIX?do=11&module=$MODULE&img=".$v["small"],0,"","",20);
 }
 }
 if (is_array($_list)) $main->setComponent("ass", new SelectComponent(i18n('assistant'), $_list, $ASS));
 while (list($key,$val) = each($STREAMS)) {
 $img = new img_resize("$NODEPATH/modules/system/template/$TPL/images/streams/login.$key");
 $img->setProp( "maxwidth", 300);
 $streamlist[$key] = $img->getImageTag("alt=\"".htmlentities($val)."\" title=\"".htmlentities($val)."\"");
 }
 if( $FEATURE['custom_streams'] ) {
 global $CUSTOM_STREAM_DIRECTORY;

 if (file_exists( $CUSTOM_STREAM_DIRECTORY )) {
 $streamdir = opendir( $CUSTOM_STREAM_DIRECTORY );
 while( false !== ($file = readdir( $streamdir )) ) {
 if (substr($file,0,6) == "login.") {
 $fullfile = "$CUSTOM_STREAM_DIRECTORY/$file";
 if(!is_file($fullfile)) continue;
 $img = new img_resize($fullfile);
 $img->setProp( "maxwidth", 300);
 $streamname = substr($file,strlen("login."));
 $streamlist[$streamname.".custom-stream"] = $img->getImageTag();
 }
 }
 }
 }
 
 $streams = new ListComponent();
 if ($FEATURE["personalloginstream"]) {
 $streams->setComponent("loginstream", new CheckboxComponent(i18n("Show personal stream on login"), !$NOLOGINSTREAM));
 }
 $streams->setComponent("streams", new RadioListComponent(i18n("Stream"), $streamlist, isset($MYSTREAM)?$MYSTREAM:$MYSTREAM_DEFAULT));

 $tab = new TabComponent();
 $tab->setTab("main", i18n("general"), $main);
 $tab->setTab("streams", i18n("Streams"), $streams);
 if ($FEATURE["progressbar"]) {
 $list = array("no"=>i18n("No progress bar"));
 if (is_array($PROGRESSBARS)) {
 foreach ( $PROGRESSBARS as $key=>$val ) {
 $list[$key] = img( "$STAG_PREFIX?do=11&module=system&img=$key" );
 }
 }
 
 $tab->setTab("progress", i18n("Progress bar"), new RadioListComponent(i18n("Progress bar"), $list, isset($MYPROGRESS)?$MYPROGRESS:$MYPROGRESS_DEFAULT) );
 }

 
 if ($DEBUG["echo"] || $USER_ID == 1) {
 node_class("detailcomponent");
 
 $dlist = new ListComponent();
 $dlist->setComponent("stream", new CheckboxComponent(i18n("Show debug stream"), $STREAMINFO_DEBUG["debug"]));
 $dlist->setComponent("exception", new CheckboxComponent(i18n("Show Exceptions"), $STREAMINFO_DEBUG["exception"]));
 $dlist->setComponent("assert", new CheckboxComponent(i18n("Enable Assertions"), $DEBUG_SETTINGS["assert"]));
 $dlist->setComponent("info", new CheckboxComponent(i18n("Show Debug info"), !$DEBUG_SETTINGS["noinfo"]));

 
 if ( $FEATURE["user_debug"] ) {
 $dcheck = new CheckboxComponent(i18n("Enable Debug Flags"), 
 isset($DEBUG_SETTINGS["debug_echo"])?$DEBUG_SETTINGS["debug_echo"]:$DEBUG["echo"]);
 $dcheck->setOnChangeAction( new SimpleFormAction("toggleDebug"));
 $dlist->setComponent("debug_echo", $dcheck);
 $modules = array();
 foreach ($DEBUG_FLAGS as $flag=>$dbg) {
 unset($dflag);
 $txt = $dbg[1];
 $module = getDbgModule($dbg);
 if (!isset($modules[$module])) {
 unset($dmod);
 $modtxt = i18n($dbg[0]);
 $dmod = new ListComponent();
 unset($ddetail);
 $ddetail = new DetailComponent($modtxt, $modtxt, $dmod);
 $dlist->setComponent("dmod_$module", $ddetail);
 $ddetail->setVisible($dcheck->isChecked());
 $modules[$module] =& $dmod;
 }
 $dflag = new CheckboxComponent(i18n($txt), isset($DEBUG_SETTINGS["debug_$flag"])?$DEBUG_SETTINGS["debug_$flag"]:$DEBUG[$flag]);
 $modules[$module]->setComponent("debug_$flag", $dflag);
 }
 }
 
 $tab->setTab("debug", i18n("Debug"), $dlist);
 }
 
 $form->setHeader(i18n("Settings"), $ICO_USER);
 $form->addComponent("tab",$tab);
 $form->addButton("save", new Button(i18n("Apply")), new SimpleFormAction("storeValues"), true);
 $form->addButton("reset", new Button(i18n("Reset Session")), new SimpleFormAction("resetSession"));
}
?>
