<?

function debug_logdotimes($d) {
 global $FILEPATH, $do, $TIME;
 $dur = calctime($d["start"],$d["end"],3);
 $fp = fopen("$FILEPATH/log/dotimes.log","a");
 fwrite($fp,"$do	$TIME	$dur	".$_SERVER["REMOTE_ADDR"]."\n");
 fclose($fp);
}

function debug($d,$T) {
 global $USER_ID;
 global $SID;
 global $COOKIE;
 global $SESSION_VAR;
 global $DO, $FILE;
 global $INC_COUNT, $CACHE_EFFORT, $QUERY_EFFORT, $TS, $DEBUG, $INCLUDE_HITS, $INCLUDE_TOT;
 $svar = count($SESSION_VAR)-1;
 $name = GUIFactory::getMainGUIName();
 if ( in_array( $name, array( "ass", "main", "tree" ) ) )
 $maxout = true;
 $dur = calctime($d["start"],$d["end"],3);
 if ($dur > 0.1) $dur = "<font color=red>$dur</font>";
 if (!$DEBUG["force_node2"] && $maxout) {
 for ( $i = 0; $i < 40; $i++ )
 echo "\n&nbsp;<br>\n";
 }
 echo "
<pre>
userid: $USER_ID
do: $DO: $FILE
sid: $SID
cookie: $COOKIE
sql selects: ".$d["select"]."
sql inserts: ".$d["insert"]."
sql updates: ".$d["update"]."
sql deletes: ".$d["delete"]."
session variables: $svar
additional includes: $INC_COUNT
additional include hits: $INCLUDE_HITS
additional include time: $INCLUDE_TOT
cache effort: $CACHE_EFFORT
query effort: $QUERY_EFFORT
times:<br>\n";
while (list($key,$val) = each($T)) {
 if (isset($T[$key+1])) echo "T$key-T".($key+1).": ".calctime($val,$T[$key+1],3)."<br>\n";
}
if (is_array($TS)) while (list($key,$val) = each($TS)) {
 echo "$key: $val<br>\n";
}
echo " 
exec time: $dur
</pre>\n";


if ($DEBUG["perf"]) echo mydb_print_query_log();

if ($DEBUG["include"] && $DEBUG["perf"] && is_array($INCLUDE_PERF)) {
 ksort($INCLUDE_PERF);
 echo "<pre>";
 var_dump($INCLUDE_PERF);
 echo "</pre>";
}
 

}
?>
