<?


function get_visible_constructs($sql_row = "construct_id", $node_id = 0, $channelfixed = false) {
 global $FEATURE;
 
 if ($FEATURE['multichannelling'] && !$channelfixed) {
 $node_id = getMasterNode($node_id, true);
 }

if ($node_id > 0) {

 $where = "node_id = ".sqlf_tl_num($node_id);

} else {

 global $USER_ID, $T_DOMAIN;

 $construct = Array();
 if (!$sql_row) halt(7,"get_visible_constructs: no sql_row($sql_row)!");

 

 $sql = "SELECT id, folder_id FROM node";
 $rs = query($sql);
 $where = "(1=2";
 if ($rs["num"] > 0) {
 while (list($key,$row) = each($rs["arr"])) {
 $id = $row["id"];
 if (perm($USER_ID, $T_DOMAIN, $row["folder_id"], 0)) 
 $where .= " OR node_id = ".sqlf_tl_num($row["id"]);
 }
 }
 $where .= ")";

}

 
 $sql = "SELECT DISTINCT construct_id FROM construct_node WHERE $where ORDER BY construct_id";
 $rs = query($sql);
 $ret = "(1=2 ";
 if ($rs["num"] > 0) {
 while (list($key,$row) = each($rs["arr"])) {
 $ret .= " OR ".sqlf_field($sql_row)." = ".sqlf_tl_num($row["construct_id"]);
 }
 }
 $ret .= ") ";

 return $ret;
}

function get_visible_construct_list($node_id = 0) {

 global $LANGUAGE;

 $sql = get_visible_constructs("construct.id", $node_id);
 $sql = "SELECT construct.id, dicuser.value AS name, LOWER(dicuser.value) AS l_name FROM construct, dicuser
	WHERE construct.name_id = dicuser.output_id AND dicuser.language_id = ".sqlf_tl_num($LANGUAGE)." AND $sql ORDER BY l_name";
 
 $rs = query($sql);
 $rs = reduce_array($rs["arr"],"id","name");
 
 return $rs;
}

?>
