<?


class selector {

 var $value = "";

 var $prefix = "";

 var $winfo = array();

 
 function selector($prefix, $info) {
 $this->prefix = $prefix;
 $this->winfo = $info;
 }

 function set_value($value) {
 $this->value = $value;
 }

 function get_text() {
 return $this->value;
 }

 function use_htmlform(&$hi,$optional=false,$readonly=false) {
 }

 
 function get_selector(&$f, $jsform = "gentics") {
 $out = "";
 return $out;
 }

 
 function is_submitted() {
 return true;
 }

 
 function get_value() {
 return $this->value;
 }
}


class group_selector extends selector {

 function group_selector($prefix,$info) {
 selector::selector($prefix,$info);
 }
 
 function get_text() {
 $val = $this->value;

 if (is_numeric($val)) {
 $sql = "SELECT name FROM usergroup WHERE id = ".sqlf_tl_num($val);
 $rs = query($sql);
 $out .= $rs["arr"][0]["name"];
 } else $out .= "-";

 return $out;
 }

 function get_selector(&$f, $jsform = "gentics") {

 global $T_GROUP, $T_GROUPADMIN, $STAG, $DO;

 $prefix = $this->prefix;

 $t = new tree();

 $t->treelink = "$STAG&do=$DO";
 $t->showasform = true;
 $t->openvar = "group_selector";

 $t->type[$T_GROUPADMIN]["allowlink"] = false;
 $t->type[$T_GROUP]["allowlink"] = true;
 $t->type[$T_GROUP]["linkvar"] = $prefix."_gid";
 $t->type[$T_GROUP]["link"] = "$STAG&do=$DO";
 $t->type[$T_GROUP]["linktarget"] = "_self";

 $rs = query("SELECT id FROM tree WHERE type_id = ".sqlf_tl_num($T_GROUPADMIN));
 $root_id = $rs['arr']['id'];

 $out = $t->walktree($root_id, false, $depth = 0, $T_GROUPADMIN, $idx = "");

 return $out;
 }

 function is_submitted() {
 $prefix = $this->prefix;

 global ${$prefix."_gid"};
 if (${$prefix."_gid"}) return true;
 else return false;
 }

 function get_value() {
 $prefix = $this->prefix;

 if ($this->is_submitted()) {
 global ${$prefix."_gid"};
 $this->value = ${$prefix."_gid"};
 }

 return $this->value;
 }

}


class user_selector extends selector {

 function user_selector($prefix,$info) {
 selector::selector($prefix,$info);
 }
 
 function get_text() {
 $val = $this->value;

 if (is_numeric($val)) {
 $sql = "SELECT firstname, lastname FROM systemuser WHERE id = ".sqlf_tl_num($val);
 $rs = query($sql);
 $out .= $rs["arr"][0]["lastname"]." ".$rs["arr"][0]["firstname"];
 } else $out .= "-";

 return $out;
 }

 function get_selector(&$f, $jsform = "gentics") {
 global $STAG, $DO, $ICO_USER;

 $out = "";

 $prefix = $this->prefix;

 node_include( "user" );
 $sql = "SELECT firstname, lastname, id, LOWER(lastname) AS l_lastname FROM systemuser WHERE active = 1 AND id > 1 AND id IN (";
 $ulist = user_get_visibleusers();
 if ($ulist) {
 $sql .= implode( ", ", sqlf_tl_num_array($ulist) );
 }
 $sql .= ") ORDER BY l_lastname";
 $rs = query($sql);

 $list = array();
 while (list($key,$val) = each($rs["arr"])) {
 $val["name"] = $val["lastname"]." ".$val["firstname"];
 $list[] = $val;
 }

 $lst = new item_list();

 $lst->nestedform = "gentics";

 $lst->cols = array("icon","name");
 $lst->rows = $list;
 $lst->head["name"] = "Benutzer";
 $lst->apptd["icon"] = addslashes(img($ICO_USER));
 $lst->link["name"] = "$STAG&do=$DO&".$prefix."_uid=\$id";

 $out .= $lst->outp();

 return $out;
 }

 function is_submitted() {
 $prefix = $this->prefix;

 global ${$prefix."_uid"};
 if (${$prefix."_uid"}) return true;
 else return false;
 }

 function get_value() {
 $prefix = $this->prefix;

 if ($this->is_submitted()) {
 global ${$prefix."_uid"};
 $this->value = ${$prefix."_uid"};
 }

 return $this->value;
 }

}

class tree_selector extends selector {

 function tree_selector($prefix, $info) {
 selector::selector($prefix, $info);
 }

}

?>
